% Solves the Burgers equation u_t + uu_x = 0.
function u = burgers(u0, x, niter, deltat)
    N = size(x,2);
    deltax = (x(N) - x(1))/(N-1);
    s = 0.5*deltat/deltax;
    
    u = zeros(niter, N);
    u(1,:) = u0;

    j = 2:N;
    for n = 2:niter
        u2 = u(n-1,:).^2;
        u(n,j) = u(n-1,j) - s*(u2(j) - u2(j-1));
    end
end
