% Solves the wave equation u_t + c*u_x = 0.
function u = wave_upwind(c, u0, x, niter, deltat)
    N = size(x,2);
    deltax = (x(N) - x(1))/(N-1);
    sigma = c*deltat/deltax;

    u = zeros(niter, N);
    u(1,:) = u0;
    
    j = 2:N;
    for n = 2:niter
        u(n,1) = u0(1); % Boundary condition.
        
        u(n,j) = u(n-1,j) - sigma*(u(n-1,j) - u(n-1,j-1));
    end
end
